package database

import (
	// "fmt"
	"log"
	"database/sql"
	_ "github.com/go-sql-driver/mysql"
	_ "github.com/mattn/go-sqlite3"
)

var (
 	Agent_db *sql.DB

)


/* This is the connection initializer for mysql */
// func InitDB (dbUser string, dbPassword string, dbHost string, dbPort int16, dbName string ) *sql.DB {
// 	var db 	 *sql.DB
// 	var err  error
// 	dbOpen := fmt.Sprintf("%s:%s@(%s:%d)/%s?parseTime=true", dbUser,dbPassword, dbHost, dbPort, dbName)
// 	db, err = sql.Open("mysql", dbOpen)
// 	if err != nil {
// 		log.Fatal(err)
// 	}

// 	if err = db.Ping(); err != nil {
// 		log.Fatal(err)
// 	}
// 	log.Println("Connected to database")

// 	return db
// }

func InitSQLiteDB(dbPath string) *sql.DB  {
	var err error
	Agent_db, err = sql.Open("sqlite3", dbPath)
	if err != nil {
	 	log.Println("Error opening DB: %w", err)
	}

	// CreateTableQuery := `CREATE TABLE IF NOT EXISTS logs (
	// 	id INTEGER PRIMARY KEY AUTOINCREMENT,
	// 	message TEXT,
	// 	timestamp DATETIME DEFAULT CURRENT_TIMESTAMP,
	// 	level TEXT
	// );`

	// 	id TEXT PRIMARY KEY DEFAULT (lower(hex(randomblob(16)))),
	CreateTableQuery :=`CREATE TABLE IF NOT EXISTS agents (
		id INTEGER PRIMARY KEY AUTOINCREMENT,
		agentId INTEGER UNIQUE,
		agentType TEXT,
		agentName TEXT,
		IPv4Address TEXT,
		initialContact datetime,
		lastContact datetime,
		addPort TEXT,
		hostname TEXT
		);`

	_, err = Agent_db.Exec(CreateTableQuery)
	if err != nil {
		log.Println("Error creating table: %w", err)
	}

	return Agent_db
}

func CloseDB() {
	if Agent_db != nil {
		err := Agent_db.Close()
		if err != nil {
			log.Println("Error closing database: %v", err)
		}
	}
}
